
	list p=16f628a
	#include<P16F628a.inc>


 	ORG 0X2007   		;       
	DW  0X3F10
	  


;--------------------------------------------------------------------------
;   flag
TAX	equ	0		;     
kal	equ	1		;    
R_OB	equ	2		;      
ras	equ	3		; 
ZAP	equ	4		;       
was_R	equ	5		;       " "
;--------------------------------------------------------------------------
CONST	equ	.230
CONS1	equ	.80
;--------------------------------------------------------------------------




;    PORTB
REVERS	equ	1		;   
SOUND	equ	2		;  



;    PORTA
DAT	equ	0		;  DAT
CLK	equ	1		;  CLK 

PARK	equ	2		;   
KALIB	equ	3		; . 
TYPE	equ	5		;  
NEYTR	equ	6		;  


;***************************************************************
;  
;***************************************************************
	cblock   H'20'		;  ,   EEPROM

	O_pered			; 20h   I 
	I_pered			; 21h  
	II_pered			; 22h  
	III_pered			; 23h  
	IV_pered			; 24h  
	V_pered			; 25h  
	SPEED			; 26h     
	TEMP1			; 27h 
	STOLBIK			; 28h   ,   
	RESULT			; 29h      
	flag			; 2Ah 
	PEREDACHA		; 2Bh  
	counter			; 2Ch 
	count_IND		; 2Dh    
	count_TAX_1		; 2Eh     
	count_TAX_2 		; 2Fh     
	endc

;***************************************************************	
	cblock	h'30'
	count_K			; 30h   
	SPEED_K_S		; 31h      
	SPEED_K_M		; 31h      
	RESULT_K		; 33h     
	SPEED_K_OLD		; 34h      
	count_Z_L		; 35h 
	count_Z_H		; 36h 
; 37h 
; 38h 
; 39h
; 3Ah	
; 3Bh
; 3Ch
; 3Dh
; 3Eh 
; 3Fh 
	endc

;***************************************************************
	cblock	h'70'

	IDEN			; 70
	w_copy			; 71
	STATUS_copy		; 72
	FSR_copy		; 73 
	D_temp			; 74 
	COPY_A			; 75
	COPY_B			; 76
	N_0			; 77
	COPY_SPEED		; 78
	TRANS			; 79
;				; 7A
;				; 7B
;				; 7C 
;				; 7D 
;				; 7E 
	endc
;***************************************************************

;***************************************************************
S_COPY	macro	s2,s3,s4,s5,s6	;     W, STATUS  FSR
	movwf	s2		;  W
	swapf	s3,0		;
	movwf	s4
	swapf	s5,0
	movwf	s6
	endm
;***************************************************************
WR_COPY	macro	wr1,wr2,wr3,wr4,wr5
	swapf	wr1,0
	movwf	wr2
	swapf	wr3,0
	movwf	wr4
	swapf	wr5,1
	swapf	wr5,0
	endm
;***************************************************************
	org	2100h
	DE	h'01',h'0E',h'19',h'23',h'32',h'3C'

	org	0x00
	goto	init 
	org	0x04
	S_COPY		w_copy,STATUS,STATUS_copy,FSR,FSR_copy
	btfss	INTCON,INTF	;   RB0
	goto	int1
	incfsz	SPEED,1
	goto	int1_1
	movlw	.19
	movwf	RESULT
int1_1	bcf	INTCON,INTF
int1	btfss	INTCON,T0IF	;   TMR0
	goto	int2
	call	RASCHET
	bcf	INTCON,T0IF
int2	btfsc	flag,R_OB
	call	OBOROTY
	btfss	PIR1,TMR2IF	;   TMR2
	goto	int3
	call	INDIKACIA
	bcf	PIR1,TMR2IF
int3	WR_COPY	STATUS_copy,STATUS,FSR_copy,FSR,w_copy
	retfie
;***************************************************************
; 

;***************************************************************
PER	macro	pp1,vv1		;  
	movfw	vv1		;   
	movwf	pp1		;  
	endm
;***************************************************************

;------------------------------------------------------------
INDIKACIA
	clrf	PORTB	
	movlw	.5
	subwf	STOLBIK,0
	btfss	STATUS,C
	goto	IN_1
	movlw	.1
	movwf	STOLBIK
	btfss	flag,TAX
	goto	IN_2
	incf	counter,1
	btfss	counter,4		;       16 "" 
	goto	IN_0
	btfss	flag,ras
	goto	IN_2	
	bcf	flag,ras
	movfw	TMR0
	movwf	N_0
	clrf	counter
	bsf	flag,R_OB	;    
	clrf	SPEED
	movlw	CONST
	movwf	TMR0
	bcf	INTCON,INTF	;      	
	bsf	INTCON,INTE	;      
	bcf	flag,TAX
	goto	IN_2
IN_0	btfsc	flag,ras		;    
	goto	IN_2		;   
	bsf	flag,ras	
	bcf	INTCON,INTE	;      
	bcf	INTCON,INTF	;      
	clrf	TMR0
	goto	IN_2
IN_1	incf	STOLBIK,1
IN_2	movfw	RESULT	
	addwf	PCL,1
	goto	INDI_0
	goto	INDI_1
	goto	INDI_2
	goto	INDI_3
	goto	INDI_4
	goto	INDI_5
	goto	INDI_6
	goto	INDI_7
	goto	INDI_8
	goto	INDI_9
	goto	INDI_10
	goto	INDI_11
	goto	INDI_12
	goto	INDI_13
	goto	INDI_14
	goto	INDI_15
	goto	INDI_16
	goto	INDI_17
	goto	INDI_18
	goto	INDI_19
	goto	INDI_20
;------------------------------------------------------------
IND_K				;   ""  
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'00010000'
	retlw	b'00101000'
	retlw	b'01000100'
	retlw	b'10000010'
;------------------------------------------------------------
IND_1				;    "1"
	addwf	PCL,1
	nop
	retlw	b'00100000'
	retlw	b'01000000'
	retlw	b'11111110'
	retlw	b'00000000'
	retlw	b'00000000'
;------------------------------------------------------------
IND_2				;    "2"
	addwf	PCL,1
	nop
	retlw	b'01000010'
	retlw	b'10000110'
	retlw	b'10001010'
	retlw	b'10010010'
	retlw	b'01100010'
;------------------------------------------------------------
IND_3				;    "3"
	addwf	PCL,1
	nop
	retlw	b'10000100'
	retlw	b'10000010'
	retlw	b'10100010'
	retlw	b'11100010'
	retlw	b'10011100'
;------------------------------------------------------------
IND_4				;    "4"
	addwf	PCL,1
	nop
	retlw	b'00011000'
	retlw	b'00101000'
	retlw	b'01001000'
	retlw	b'11111110'
	retlw	b'00001000'
;------------------------------------------------------------
IND_5				;    "5"
	addwf	PCL,1
	nop
	retlw	b'11100010'
	retlw	b'10100010'
	retlw	b'10100010'
	retlw	b'10100010'
	retlw	b'10011100'
;------------------------------------------------------------
IND_R				;     "R"
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'10010000'
	retlw	b'10011000'
	retlw	b'10010100'
	retlw	b'01100010'
;------------------------------------------------------------
IND_P				;    "P"
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'10010000'
	retlw	b'10010000'
	retlw	b'10010000'
	retlw	b'01100000'
;------------------------------------------------------------
IND_UP				;   ""
	addwf	PCL,1
	nop
	retlw	b'00100000'
	retlw	b'01000000'
	retlw	b'11111110'
	retlw	b'01000000'
	retlw	b'00100000'
;------------------------------------------------------------
IND_DOWN			;   ""
	addwf	PCL,1
	nop
	retlw	b'00001000'
	retlw	b'00000100'
	retlw	b'11111110'
	retlw	b'00000100'
	retlw	b'00001000'
;------------------------------------------------------------
IND_SCEP			;   ""
	addwf	PCL,1
	nop
	retlw	b'01111100'
	retlw	b'10000010'
	retlw	b'10000010'
	retlw	b'10000010'
	retlw	b'01000100'
;------------------------------------------------------------
IND_ENG			;   ""
	addwf	PCL,1
	nop
	retlw	b'00001100'
	retlw	b'01111000'
	retlw	b'10001000'
	retlw	b'11111000'
	retlw	b'00001100'
;------------------------------------------------------------
IND_NTR			;   "N" - 
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'00100000'
	retlw	b'00010000'
	retlw	b'00001000'
	retlw	b'11111110'
;------------------------------------------------------------
IND_1_3				;   1000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00000110'
	retlw	b'00000110'
;------------------------------------------------------------
IND_2_3				;   2000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00001110'
	retlw	b'00001110'
;------------------------------------------------------------
IND_3_3				;   3000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00011110'
	retlw	b'00011110'
;------------------------------------------------------------
IND_4_3				;   4000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00111110'
	retlw	b'00111110'
;------------------------------------------------------------
IND_5_3				;   5000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'01111110'
	retlw	b'01111110'
;------------------------------------------------------------
IND_6_3				;   > 5500 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'11111110'
	retlw	b'11111110'
	retlw	b'11111110'
	retlw	b'11111110'
;------------------------------------------------------------
IND_7_3				;   0 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00000000'
	retlw	b'00000000'
;------------------------------------------------------------
IND_8_3				;   < 1000 /
	addwf	PCL,1
	nop
	retlw	b'11111110'
	retlw	b'01010100'
	retlw	b'00000000'
	retlw	b'00000010'
	retlw	b'00000010'
;------------------------------------------------------------
IND_STOLB
	addwf	PCL,1
	nop
	retlw	b'10000000'	; RB7
	retlw	b'01000000'	; RB6
	retlw	b'00100000'	; RB5
	retlw	b'00010000'	; RB4
	retlw	b'00001000'	; RB3
;------------------------------------------------------------
INDI_0	movfw	STOLBIK
	call	IND_K
	call	IND_OUT	
	goto	INDI_END
INDI_1	movfw	STOLBIK
	call	IND_1
	call	IND_OUT	
	goto	INDI_END
INDI_2	movfw	STOLBIK
	call	IND_2
	call	IND_OUT	
	goto	INDI_END
INDI_3	movfw	STOLBIK
	call	IND_3
	call	IND_OUT	
	goto	INDI_END
INDI_4	movfw	STOLBIK
	call	IND_4
	call	IND_OUT	
	goto	INDI_END
INDI_5	movfw	STOLBIK
	call	IND_5
	call	IND_OUT	
	goto	INDI_END
INDI_6	movfw	STOLBIK
	call	IND_R
	call	IND_OUT	
	goto	INDI_END
INDI_7	movfw	STOLBIK
	call	IND_P
	call	IND_OUT	
	goto	INDI_END
INDI_8	movfw	STOLBIK
	call	IND_UP
	call	IND_OUT	
	goto	INDI_END
INDI_9	movfw	STOLBIK
	call	IND_DOWN
	call	IND_OUT	
	goto	INDI_END
INDI_10	movfw	STOLBIK
	call	IND_SCEP
	call	IND_OUT	
	goto	INDI_END
INDI_11	movfw	STOLBIK
	call	IND_1_3
	call	IND_OUT	
	goto	INDI_END
INDI_12	movfw	STOLBIK
	call	IND_2_3
	call	IND_OUT	
	goto	INDI_END
INDI_13	movfw	STOLBIK
	call	IND_3_3
	call	IND_OUT	
	goto	INDI_END
INDI_14	movfw	STOLBIK
	call	IND_4_3
	call	IND_OUT	
	goto	INDI_END
INDI_15	movfw	STOLBIK
	call	IND_5_3
	call	IND_OUT	
	goto	INDI_END
INDI_16	movfw	STOLBIK
	call	IND_6_3
	call	IND_OUT	
	goto	INDI_END
INDI_17	movfw	STOLBIK
	call	IND_7_3
	call	IND_OUT	
	goto	INDI_END
INDI_18	movfw	STOLBIK
	call	IND_8_3
	call	IND_OUT	
	goto	INDI_END
INDI_19	movfw	STOLBIK
	call	IND_ENG
	call	IND_OUT	
	goto	INDI_END
INDI_20	movfw	STOLBIK
	call	IND_NTR
	call	IND_OUT	
	goto	INDI_END

INDI_END
	movfw	STOLBIK
	call	IND_STOLB
	movwf	COPY_B
	btfss	COPY_A,TYPE	;  SA2 ?  -     
	comf	COPY_B,1	; ,      -  
; ***   
	btfss	PORTB,REVERS	;  " "  ?
	goto	I_END_1		;  -  ( ),   
	incfsz	count_Z_L,1
	goto	I_END_3
;	bcf	COPY_B,SOUND
	incfsz	count_Z_H,1
I_END_3	btfss	count_Z_H,0	;     
	goto	I_END_1
	movlw	.0
	call	IND_OUT		
	bsf	COPY_B,SOUND	
	goto	I_END_2
I_END_1	bcf	COPY_B,SOUND
I_END_2	movfw	COPY_B
	movwf	PORTB

	movf	count_IND,1	;    ,   
	btfsc	STATUS,Z	; ,  
	goto	I_END_4
	decf	count_IND,1



I_END_4	btfsc	flag,TAX
	return
	incfsz	count_TAX_1,1
	return
	incf	count_TAX_2,1
	btfss	count_TAX_2,1
	return
	bsf	flag,TAX
	clrf	count_TAX_1
	clrf	count_TAX_2
	return
;------------------------------------------------------------
IND_OUT	
	movwf	D_temp
	btfsc	COPY_A,TYPE	;  SA2 ?  -     
	comf	D_temp,1	; ,      - 
	movlw	.8
	movwf	TEMP1
agane1	bcf	COPY_A,CLK
	movfw	COPY_A
	movwf	PORTA
	bcf	STATUS,C
	rrf	D_temp,1
	movfw	D_temp
	btfsc	STATUS,C
	goto	set_hi1
	bcf	COPY_A,DAT
	movfw	COPY_A
	movwf	PORTA
	goto	clokit
set_hi1	bsf	COPY_A,DAT
	movfw	COPY_A
	movwf	PORTA
clokit	bsf	COPY_A,CLK
	movfw	COPY_A
	movwf	PORTA
	decfsz	TEMP1,1
	goto	agane1
	return
;------------------------------------------------------------
RASCHET
	movf	count_IND,1	;    ,   
	btfss	STATUS,Z	; ,      
	goto	R_END

	btfsc	PORTB,REVERS	;   ? ,    
	goto	R_END		;    - ,  
	
	btfsc	flag,kal		;  ? 
	goto	R_K_1		;  - ,  
	
R_000	movf	SPEED,1
	btfsc	STATUS,Z	;   ?
	goto	R_END		;  - 

R_00	movfw	SPEED
	subwf	O_pered,0
	btfss	STATUS,C	;    ?
	goto	R_0		;  - , 
	movlw	.1		;     #  .10
	movwf	RESULT
	goto	R_END

R_0	movfw	SPEED
	subwf	I_pered,0
	btfss	STATUS,C
	goto	R_1
	movlw	.1
	movwf	RESULT
	movwf	PEREDACHA
	goto	R_END

R_1	movfw	SPEED
	subwf	II_pered,0
	btfss	STATUS,C
	goto	R_2
	movlw	.2
	movwf	RESULT
	movwf	PEREDACHA
	goto	R_END

R_2	movfw	SPEED
	subwf	III_pered,0
	btfss	STATUS,C
	goto	R_3
	movlw	.3
	movwf	RESULT
	movwf	PEREDACHA
	goto	R_END

R_3	movfw	SPEED
	subwf	IV_pered,0
	btfss	STATUS,C
	goto	R_4
	movlw	.4
	movwf	RESULT
	movwf	PEREDACHA
	goto	R_END

R_4	movfw	SPEED
	subwf	V_pered,0
	btfss	STATUS,C
	goto	R_5
	movlw	.5
	movwf	RESULT
	movwf	PEREDACHA
	goto	R_END
R_5	movlw	.10		;    
	movwf	RESULT
	goto	R_END

R_END	movfw	SPEED
	movwf	COPY_SPEED
	clrf	SPEED
	movlw	CONST
	movwf	TMR0
	return

R_K_1	movlw	.0
	movwf	RESULT
	movlw	.5
	subwf	RESULT_K,0
	btfss	STATUS,C
	goto	R_K_2
	clrf	RESULT
	bsf	flag,ZAP
	goto	R_K_5
R_K_2	movlw	.8
	subwf	count_K,0
	btfsc	STATUS,C
	goto	R_K_3
	movf	SPEED,1
	btfsc	STATUS,Z	;   ?
	goto	R_K_5		;  -  ,  ,  -   
	movfw	O_pered		; SPEED  O_pered ?  -  ,  - 
	subwf	SPEED,0
	btfss	STATUS,C
	goto	R_K_5	
	incf	count_K,1
	bcf	STATUS,C
	movfw	SPEED
	addwf	SPEED_K_M,1
	btfss	STATUS,C
	goto	R_K_4
	movlw	.1
	addwf	SPEED_K_S,1
R_K_4	clrf	SPEED
	goto	R_K_5
R_K_3	clrf	count_K
	bcf	STATUS,C
	rrf	SPEED_K_S,1
	rrf	SPEED_K_M,1
	bcf	STATUS,C
	rrf	SPEED_K_S,1
	rrf	SPEED_K_M,1
	bcf	STATUS,C
	rrf	SPEED_K_S,1
	rrf	SPEED_K_M,1
	movlw	.8		;  SPEED_K_M    SPEED_K_OLD
	subwf	SPEED_K_M,0	;       STATUS  , 
	subwf	SPEED_K_OLD,0	; ,    () 
	btfss	STATUS,C	;      STATUS  ,   
	goto	R_K_6		;   ,     
	movfw	RESULT_K	;   
	movwf	RESULT
	goto	R_K_5
R_K_6	incf	RESULT_K,1
	movfw	RESULT_K
	movwf	RESULT
	movfw	SPEED_K_M
	movwf	SPEED_K_OLD
	movlw	20h
	movwf	FSR
	movfw	RESULT_K
	addwf	FSR,1
	movfw	SPEED_K_M
	movwf	INDF
R_K_5	movlw	CONS1*2
	movwf	count_IND	
	return
;------------------------------------------------------------
OBOROTY
	movf	COPY_SPEED,1
	btfss	STATUS,Z	;   ?
	goto	OB_8
	movf	N_0,1
	btfss	STATUS,Z
	goto	OB_1
	movlw	.17
	movwf	RESULT
	goto	OB_END
OB_1	movlw	.8
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_2
	movlw	.18
	movwf	RESULT
	goto	OB_END
OB_2	movlw	.18
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_3
	movlw	.11
	movwf	RESULT
	goto	OB_END	
OB_3	movlw	.26
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_4
	movlw	.12
	movwf	RESULT
	goto	OB_END	
OB_4	movlw	.34
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_5
	movlw	.13
	movwf	RESULT
	goto	OB_END	
OB_5	movlw	.44
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_6
	movlw	.14
	movwf	RESULT
	goto	OB_END	
OB_6	movlw	.48
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_7
	movlw	.15
	movwf	RESULT
	goto	OB_END	
OB_7	movlw	.16
	movwf	RESULT
	goto	OB_END	
	movlw	CONS1
	movwf	count_IND
OB_8	movf	N_0,1
	btfss	STATUS,Z
	goto	OB_14
	movlw	.19
	movwf	RESULT
	movlw	CONS1
	movwf	count_IND
	goto	OB_END
OB_14	movlw	.10
	subwf	N_0,0
	btfsc	STATUS,C
	goto	OB_10
	movlw	.3
	subwf	PEREDACHA,0
	btfsc	STATUS,Z
	goto	OB_9
	movlw	.4
	subwf	PEREDACHA,0
	btfsc	STATUS,Z
	goto	OB_9
	movlw	.5
	subwf	PEREDACHA,0
	btfss	STATUS,Z
	goto	OB_END
OB_9	movlw	.9
	movwf	RESULT
	movlw	CONS1
	movwf	count_IND
	goto	OB_END
OB_10	movlw	.1
	subwf	PEREDACHA,0
	btfsc	STATUS,Z
	goto	OB_11
	movlw	.2
	subwf	PEREDACHA,0
	btfss	STATUS,Z
	goto	OB_12	
OB_11	movlw	.26
	subwf	N_0,0
	btfss	STATUS,C
	goto	OB_END	
	movlw	.8
	movwf	RESULT
	movlw	CONS1
	movwf	count_IND
	goto	OB_END
OB_12	movlw	.40
	subwf	N_0,0
	btfss	STATUS,C
	goto	OB_END
	movlw	.3
	subwf	PEREDACHA,0
	btfsc	STATUS,Z
	goto	OB_13
	movlw	.4
	subwf	PEREDACHA,0
	btfss	STATUS,Z
	goto	OB_END	
OB_13	movlw	.8
	movwf	RESULT
	movlw	CONS1
	movwf	count_IND

OB_END	
	bcf	flag,R_OB

	return
;***************************************************************
; 
;***************************************************************	

init				;  
	movlw	20h
	movwf	FSR
clear	clrf	INDF
	incf	FSR,1
	movlw	80h
	subwf	FSR,0
	btfss	STATUS,Z
	goto	clear 
	clrwdt
	movlw	.1
	movwf	STOLBIK
	clrf	INTCON
	clrf	PORTB	
	clrf	PORTA		;   
	movlw	h'07'		;  
	movwf	CMCON		;  R0 - RA5 -  /
ttrr	bsf	STATUS,RP0
	movlw	b'11111100'	; RA1 - RA2 
	movwf	TRISA		; RA0, RA3 - RA4 
	movlw	b'11101111'	;   , 
	movwf	OPTION_REG	;   WDT,  TMR0   
	movlw	B'00000011'	;  RB0  RB1  ,
	movwf	TRISB		;   
	movlw	B'11110000'	;    ,  TMR0   RB0
	movwf	INTCON		; 
	movlw	B'00000010'	;    TMR2
	movwf	PIE1
	movlw	.250
	movwf	PR2
	bcf	STATUS,RP0
	movlw	b'01100100'	;  3,2630 
	movwf	T2CON
	movlw	.0
	movwf	STOLBIK

	movlw	.17
	movwf	RESULT		;  ""  

	movlw	CONST
	movwf	TMR0

;	movlw	CONS1
;	movwf	count_IND

	call	READ_pered

;***************************************************************
;   
;***************************************************************
cikl	movfw	PORTB
	movwf	COPY_B
	movfw	PORTA
	movwf	COPY_A

	btfss	PORTB,REVERS
	goto	C_1
	movlw	.6		;   "R" -  
	movwf	RESULT
	btfsc	flag,was_R
	goto	cikl
	bsf	flag,was_R
	bsf	COPY_B,SOUND
	goto	cikl
C_1	bcf	flag,was_R
	clrf	count_Z_L
	clrf	count_Z_H
	btfsc	COPY_A,NEYTR
	goto	C_2	
	movlw	.20		;   "N" -  
	movwf	RESULT
C_2	btfsc	COPY_A,PARK
	goto	C_3	
	movlw	.7		;   "P" -  
	movwf	RESULT	
C_3	btfsc	COPY_A,KALIB
	goto	C_4
	bsf	flag,kal
	goto	cikl
C_4	btfss	flag,kal
	goto	cikl
	btfsc	flag,ZAP
	call	ZAP_pered	
	bcf	flag,kal
	goto	cikl
;***************************************************************
ZAP_pered			;     EEDATA
	bcf	INTCON,GIE
	bcf	PIR1,EEIF
	movlw	.4
	subwf	I_pered,0
	movwf	O_pered
	movlw	h'20'
	movwf	IDEN
uu1	clrwdt
	bsf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	h'20'
	subwf	IDEN,0		 
	movwf	EEADR
	movfw	IDEN
	movwf	FSR
	movfw	INDF
	movwf	EEDATA
	bsf	EECON1,WREN
	movlw	h'55'
	movwf	EECON2
	movlw	h'AA'
	movwf	EECON2	
	bsf	EECON1,WR
	bcf	EECON1,WREN
	bcf	STATUS,RP0
	bcf	STATUS,RP1
pov	btfss	PIR1,EEIF
	goto	pov
	bcf	PIR1,EEIF
	incf	IDEN,1
	movlw	h'26'		;     EEPROM   h'25' 
	subwf	IDEN,0
	btfss	STATUS,Z
	goto	uu1
	movlw	20h	
	movwf	IDEN
	bcf	flag,ZAP
	bsf	INTCON,GIE
	return
;***************************************************************
READ_pered			;     EEDATA
	bcf	INTCON,GIE
	movlw	h'20'
	movwf	IDEN
ss1	clrwdt
	bsf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	h'20'
	subwf	IDEN,0
	movwf	EEADR
	bsf	EECON1,RD
	movfw	EEDATA
	movwf	TRANS
	movfw	IDEN
	movwf	FSR
	movfw	TRANS
	movwf	INDF
	incf	IDEN,1
	movlw	h'26'		;    EEPROM   h'25'  
	subwf	IDEN,0
	btfss	STATUS,Z
	goto	ss1
	bcf	STATUS,RP0
	bcf	STATUS,RP1
	movlw	20h	
	movwf	IDEN
	bsf	INTCON,GIE
	return
;***************************************************************
	end